"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ParserError_1 = require("./ParserError");
class ParserErrorRequiredPropNotSet extends ParserError_1.ParserError {
    constructor(path) {
        super(`The required property at path(${path}) was not set or null`, ParserError_1.ParserErrorCodes.RequiredPropNotSet);
    }
}
exports.ParserErrorRequiredPropNotSet = ParserErrorRequiredPropNotSet;
class ParserErrorPropIsInvalid extends ParserError_1.ParserError {
    constructor(path, value) {
        super(`The property at path(${path}) with value(${value}) was not valid`, ParserError_1.ParserErrorCodes.PropIsInvalid);
    }
}
exports.ParserErrorPropIsInvalid = ParserErrorPropIsInvalid;
exports.ParserErrorBuilders = {
    PropIsInvalid: (path, _value) => new ParserErrorRequiredPropNotSet(path),
    RequiredPropNotSet: (path, value) => new ParserErrorPropIsInvalid(path, value),
};
//# sourceMappingURL=ParserErrors.js.map