"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
class Handler {
    static invokeOrHandle(handler, params, handlerObj, defaultVal) {
        if (_.isFunction(handler)) {
            const func = handler;
            return func(...params);
        }
        if (_.isString(handler)) {
            const funcName = handler;
            return handlerObj[funcName](...params);
        }
        if (_.isObject(handler)) {
            const { f: funcBuilder, p: funcBuilderParamsAsObj } = handler;
            return _.isFunction(funcBuilder)
                ? funcBuilder(funcBuilderParamsAsObj)(...params)
                : handlerObj.Builders[funcBuilder](funcBuilderParamsAsObj)(...params);
        }
        return defaultVal;
    }
    static reduceHandler(handler, reducer, initVal) {
        return handler != null
            ? _.castArray(handler).reduce(reducer, initVal)
            : initVal;
    }
}
exports.Handler = Handler;
//# sourceMappingURL=Handler.js.map