"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const validator_1 = require("validator");
const _ = require("lodash");
const Handler_1 = require("./Handler");
exports.Sanitizers = Object.assign(validator_1.default, {
    Builders: {},
    invoke(parserMiddleware, ...params) {
        return Handler_1.Handler.invokeOrHandle(parserMiddleware, params, exports.Sanitizers, null);
    },
    email(email) {
        const sanitized = validator_1.default.normalizeEmail(validator_1.default.trim(email), {
            all_lowercase: false,
            gmail_lowercase: true,
            gmail_remove_subaddress: true,
            outlookdotcom_lowercase: true,
            outlookdotcom_remove_subaddress: true,
            yahoo_lowercase: true,
            yahoo_remove_subaddress: true,
            icloud_lowercase: true,
            icloud_remove_subaddress: true,
        });
        return _.isString(sanitized)
            ? sanitized
            : '';
    },
});
//# sourceMappingURL=Sanitizers.js.map