"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ParamParser_1 = require("./ParamParser");
const ErrorHandlers_1 = require("../lib/ErrorHandlers");
class Parser {
    static parse(object, params) {
        return params
            .reduce((paramParser, option) => paramParser.add(option), new ParamParser_1.ParamParser())
            .parse(object);
    }
    static parser() {
        return new ParamParser_1.ParamParser();
    }
    static httpParser() {
        return new ParamParser_1.ParamParser()
            .withCustomErrorHandler(ErrorHandlers_1.ErrorHandlers.http);
    }
}
exports.Parser = Parser;
//# sourceMappingURL=Parser.js.map